// 0226
//
//
//
//
// ! 콜백
// 콜 스택 : 스택은 기본 컴퓨터 데이터 구조
// LIFO 구조로 알려져있음 (후입선출)
// 여러함수를 호출하는 스크립트 에서 해당위치를 추적

// * 스크립트가 함수를 호출하면 해석기는 콜 스택에 추가함

// * 그 함수(A)가 실행 // if, 함수 A 가 함수 B를 호출시 함수 B도 콜 스택 추가

// * 함수 완료시 콜스택에서 제거 / 마지막 코드 목록에서 계속 실행

// 예시 1)

/*곱하기 함수 */
const 곱셈 = (x, y) => x * y; // ?
/*제곱 함수*/
const 제곱 = (x) => 곱셈(x, x); // ?
/*피타고라스 정리 함수*/
const 피타고라스확인 = (a, b, c) => 제곱(a) + 제곱(b) === 제곱(c); // ?

피타고라스확인(3, 4, 5); //?

const 덧셈 = (x, y) => x + y;

덧셈(4, 5); // ?

// 제곱은 곱셈을 호출
// 피타고라스는 제곱을 호출 -> 곱셈을 호출

//^ 콜스택 순서
//
//^ 1. 피타고라스확인 함수가 호출 되면 맨 처음에 깔린다.
//^ 2. 첫번째 명령문인 제곱(a)가 호출된다.
//^ 3. 제곱(a)이 호출되고 명령문인 곱셈()가 호출된다.
//^ 4. 곱셈()의 return 값 반환 ( 3 )
//^ 5. 곱셈()의 추가함수 호출이 없으니 콜스택 삭제
//^ 6. 제곱 함수는 곱셈함수의 반환값으로 계산 후 return 값 반환 ( 9 )
//^ 7. 제곱(a)의 추가함수 호출이 없으니 콜스택 삭제
//^ 8. 피타고라스확인 함수의 첫번째 명령문 값 확인 (제곱(a))
//^ 9. 피타고라스확인 함수의 두번째 명령문 제곱(b)호출
//^ 10. 반복.
//^ End. 피타고라스확인 함수의 return 값이 나옴

//& 콜스택을 확인하기 위해선 latentflip.com/loupe 에서 확인 할 수 있다,
//& 크롬 콘솔탭에서도 콜스택 확인 할 수 있다.

//! 자바스크립트는 싱글 쓰레드다.
//한줄씩 읽어서 실행한다는 뜻
//

//싱글 쓰레드 예시

const input = document.querySelector('#input');
const newTodo = input.value; // get user input
saveToDatabase(newTodo); // this could take a while;
input.value = ''; //reset form

// 값을가져오는데 오래 걸리고 / 값을 추출하는데 오래 걸린다면
// 사용자입장에서 좋지 않음.
//* 오래걸리는 함수작동 해결법 : setTimeout

//예시3

console.log('먼저 실행');
setTimeout(() => {
  console.log('3초후 실행(마지막)');
}, 3000);
console.log('두번째 실행');

//예시4
console.log('서버에 요청중');
setTimeout(() => {
  console.log('서버에서 데이터 받아오는 칸');
}, 3000);
console.log('파일 마지막');
// 서버에요청중 - 파일 마지막 - 3초뒤 - 서버에서 데이터 받아오는 칸 ㅜㄴ으로 나옴

// 브라우저는 webAPIS란게 존재
// 일반적으로 Js에서 호출하여  브라우저로 전달
//* Js가 처리하지못하는 몇개의 함수를 브라우저에게 처리해달라고 요청
//* 브라우저에게 setTimeout 을 전달 -> 브라우저에서 작동 ->
//* setTimeout 내부 함수(콜백함수)를 Js에게 전달 -> JS가 함수 작동


// ! 콜백이라는 지옥

// app.js